/* ANCHOR: all */
# Ceremony Repository

// ANCHOR: content
This repository holds data pertaining to ceremonies. The primary data consists of:

* Transaction proposals

* Transaction approvals

* Trusted PGP keyring

* Shardfile

* Policies (such as spending rules)

* Ceremony logs 

## Directives

* MUST be a private repository

* MUST be write protected, requiring approval from at least 1 individual other than one who opened the PR for merging

* MUST require signed commits

## Repository Structure

```
<namespace>
    <ceremonies/>
        <date>/
            log.txt
                - [ ] TODO: write a layout for the log
            payloads/
                payload_<num>.json
                payload_<num>.json.sig
    blockchain_metadata/
        sol_nonce_address.txt
    policies/
        spending-policy.json [NOT IMPLEMENTED]
    keyring.asc
        TODO figure out if we are doing detached sigs
    shardfile.asc
```

## Procedure: Setting up Repository

{{ #include ./git-repository-initialization.md:procedure}}

## Procedure: Adding a OpenPGP Public Certificate

1. Open a PR submitting the public key to the repository

    * MUST be via commit signed by the PGP key being submitted to the repository

1. One other individual should review the PR and verify that the key belongs to the individual using an out of band channel

1. If validates successfully the reviewer should create a detached signature of the key using:

    * `gpg --detach-sign <file_name>`

1. The detached signature should be added to the PR and then the PR should be merged

// ANCHOR_END: content
/* ANCHOR_END: all */

